# DO NOT EDIT! This file is automatically generated

import re

import marshmallow
import marshmallow_enum

from commercetools import helpers, types
from commercetools.schemas._base import (
    PagedQueryResponseSchema,
    UpdateActionSchema,
    UpdateSchema,
)
from commercetools.schemas._common import (
    LocalizedStringField,
    ReferenceSchema,
    ResourceSchema,
)
from commercetools.schemas._type import FieldContainerField

__all__ = [
    "AttributeSchema",
    "CustomTokenizerSchema",
    "FacetResultRangeSchema",
    "FacetResultSchema",
    "FacetResultTermSchema",
    "FacetResultsSchema",
    "FilteredFacetResultSchema",
    "ProductAddAssetActionSchema",
    "ProductAddExternalImageActionSchema",
    "ProductAddPriceActionSchema",
    "ProductAddToCategoryActionSchema",
    "ProductAddVariantActionSchema",
    "ProductCatalogDataSchema",
    "ProductChangeAssetNameActionSchema",
    "ProductChangeAssetOrderActionSchema",
    "ProductChangeMasterVariantActionSchema",
    "ProductChangeNameActionSchema",
    "ProductChangePriceActionSchema",
    "ProductChangeSlugActionSchema",
    "ProductDataSchema",
    "ProductDraftSchema",
    "ProductLegacySetSkuActionSchema",
    "ProductMoveImageToPositionActionSchema",
    "ProductPagedQueryResponseSchema",
    "ProductProjectionPagedQueryResponseSchema",
    "ProductProjectionPagedSearchResponseSchema",
    "ProductProjectionSchema",
    "ProductPublishActionSchema",
    "ProductReferenceSchema",
    "ProductRemoveAssetActionSchema",
    "ProductRemoveFromCategoryActionSchema",
    "ProductRemoveImageActionSchema",
    "ProductRemovePriceActionSchema",
    "ProductRemoveVariantActionSchema",
    "ProductRevertStagedChangesActionSchema",
    "ProductRevertStagedVariantChangesActionSchema",
    "ProductSchema",
    "ProductSetAssetCustomFieldActionSchema",
    "ProductSetAssetCustomTypeActionSchema",
    "ProductSetAssetDescriptionActionSchema",
    "ProductSetAssetKeyActionSchema",
    "ProductSetAssetSourcesActionSchema",
    "ProductSetAssetTagsActionSchema",
    "ProductSetAttributeActionSchema",
    "ProductSetAttributeInAllVariantsActionSchema",
    "ProductSetCategoryOrderHintActionSchema",
    "ProductSetDescriptionActionSchema",
    "ProductSetDiscountedPriceActionSchema",
    "ProductSetImageLabelActionSchema",
    "ProductSetKeyActionSchema",
    "ProductSetMetaDescriptionActionSchema",
    "ProductSetMetaKeywordsActionSchema",
    "ProductSetMetaTitleActionSchema",
    "ProductSetPricesActionSchema",
    "ProductSetProductPriceCustomFieldActionSchema",
    "ProductSetProductPriceCustomTypeActionSchema",
    "ProductSetProductVariantKeyActionSchema",
    "ProductSetSearchKeywordsActionSchema",
    "ProductSetSkuActionSchema",
    "ProductSetTaxCategoryActionSchema",
    "ProductTransitionStateActionSchema",
    "ProductUnpublishActionSchema",
    "ProductUpdateActionSchema",
    "ProductUpdateSchema",
    "ProductVariantAvailabilitySchema",
    "ProductVariantChannelAvailabilityMapSchema",
    "ProductVariantChannelAvailabilitySchema",
    "ProductVariantDraftSchema",
    "ProductVariantSchema",
    "RangeFacetResultSchema",
    "SearchKeywordSchema",
    "SearchKeywordsSchema",
    "SuggestTokenizerSchema",
    "SuggestionResultSchema",
    "SuggestionSchema",
    "TermFacetResultSchema",
    "WhitespaceTokenizerSchema",
]


class CategoryOrderHintsField(marshmallow.fields.Dict):
    def _deserialize(self, value, attr, data):
        result = super()._deserialize(value, attr, data)
        return types.CategoryOrderHints(**result)


class AttributeSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.Attribute`."
    name = marshmallow.fields.String(allow_none=True)
    value = marshmallow.fields.Raw(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.Attribute(**data)


class FacetResultRangeSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.FacetResultRange`."
    from_ = marshmallow.fields.Integer(allow_none=True, data_key="from")
    from_str = marshmallow.fields.String(allow_none=True, data_key="fromStr")
    to = marshmallow.fields.Integer(allow_none=True)
    to_str = marshmallow.fields.String(allow_none=True, data_key="toStr")
    count = marshmallow.fields.Integer(allow_none=True)
    product_count = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="productCount"
    )
    total = marshmallow.fields.Integer(allow_none=True)
    min = marshmallow.fields.Integer(allow_none=True)
    max = marshmallow.fields.Integer(allow_none=True)
    mean = marshmallow.fields.Integer(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.FacetResultRange(**data)


class FacetResultSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.FacetResult`."
    type = marshmallow_enum.EnumField(types.FacetTypes, by_value=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.FacetResult(**data)


class FacetResultTermSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.FacetResultTerm`."
    term = marshmallow.fields.Raw(allow_none=True)
    count = marshmallow.fields.Integer(allow_none=True)
    product_count = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="productCount"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.FacetResultTerm(**data)


class FacetResultsSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.FacetResults`."
    _regex = helpers.RegexField(
        unknown=marshmallow.EXCLUDE,
        pattern=re.compile("^[a-z].*$"),
        type=helpers.Discriminator(
            discriminator_field=("type", "type"),
            discriminator_schemas={
                "filter": "commercetools.schemas._product.FilteredFacetResultSchema",
                "range": "commercetools.schemas._product.RangeFacetResultSchema",
                "terms": "commercetools.schemas._product.TermFacetResultSchema",
            },
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        ),
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        data = self.fields["_regex"].postprocess(data)
        return types.FacetResults(**data)

    @marshmallow.pre_load
    def pre_load(self, data):
        data = self.fields["_regex"].preprocess(data)
        return data

    @marshmallow.pre_dump
    def pre_dump(self, data):
        data = self.fields["_regex"].preprocess(data)
        return data

    @marshmallow.post_dump
    def post_dump(self, data):
        data = self.fields["_regex"].postprocess(data)
        return data


class ProductCatalogDataSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ProductCatalogData`."
    published = marshmallow.fields.Bool(allow_none=True)
    current = marshmallow.fields.Nested(
        nested="commercetools.schemas._product.ProductDataSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    staged = marshmallow.fields.Nested(
        nested="commercetools.schemas._product.ProductDataSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    has_staged_changes = marshmallow.fields.Bool(
        allow_none=True, data_key="hasStagedChanges"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ProductCatalogData(**data)


class ProductDataSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ProductData`."
    name = LocalizedStringField(allow_none=True)
    categories = marshmallow.fields.Nested(
        nested="commercetools.schemas._category.CategoryReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )
    category_order_hints = CategoryOrderHintsField(
        allow_none=True, missing=None, data_key="categoryOrderHints"
    )
    description = LocalizedStringField(allow_none=True, missing=None)
    slug = LocalizedStringField(allow_none=True)
    meta_title = LocalizedStringField(
        allow_none=True, missing=None, data_key="metaTitle"
    )
    meta_description = LocalizedStringField(
        allow_none=True, missing=None, data_key="metaDescription"
    )
    meta_keywords = LocalizedStringField(
        allow_none=True, missing=None, data_key="metaKeywords"
    )
    master_variant = marshmallow.fields.Nested(
        nested="commercetools.schemas._product.ProductVariantSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="masterVariant",
    )
    variants = marshmallow.fields.Nested(
        nested="commercetools.schemas._product.ProductVariantSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )
    search_keywords = marshmallow.fields.Nested(
        nested="commercetools.schemas._product.SearchKeywordsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="searchKeywords",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ProductData(**data)


class ProductDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ProductDraft`."
    product_type = marshmallow.fields.Nested(
        nested="commercetools.schemas._product_type.ProductTypeReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="productType",
    )
    name = LocalizedStringField(allow_none=True)
    slug = LocalizedStringField(allow_none=True)
    key = marshmallow.fields.String(allow_none=True, missing=None)
    description = LocalizedStringField(allow_none=True, missing=None)
    categories = marshmallow.fields.Nested(
        nested="commercetools.schemas._category.CategoryReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )
    category_order_hints = CategoryOrderHintsField(
        allow_none=True, missing=None, data_key="categoryOrderHints"
    )
    meta_title = LocalizedStringField(
        allow_none=True, missing=None, data_key="metaTitle"
    )
    meta_description = LocalizedStringField(
        allow_none=True, missing=None, data_key="metaDescription"
    )
    meta_keywords = LocalizedStringField(
        allow_none=True, missing=None, data_key="metaKeywords"
    )
    master_variant = marshmallow.fields.Nested(
        nested="commercetools.schemas._product.ProductVariantDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="masterVariant",
    )
    variants = marshmallow.fields.Nested(
        nested="commercetools.schemas._product.ProductVariantDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )
    tax_category = marshmallow.fields.Nested(
        nested="commercetools.schemas._tax_category.TaxCategoryReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="taxCategory",
    )
    search_keywords = marshmallow.fields.Nested(
        nested="commercetools.schemas._product.SearchKeywordsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="searchKeywords",
    )
    state = marshmallow.fields.Nested(
        nested="commercetools.schemas._state.StateReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    publish = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ProductDraft(**data)


class ProductPagedQueryResponseSchema(PagedQueryResponseSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductPagedQueryResponse`."
    results = marshmallow.fields.Nested(
        nested="commercetools.schemas._product.ProductSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ProductPagedQueryResponse(**data)


class ProductProjectionPagedQueryResponseSchema(PagedQueryResponseSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductProjectionPagedQueryResponse`."
    results = marshmallow.fields.Nested(
        nested="commercetools.schemas._product.ProductProjectionSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ProductProjectionPagedQueryResponse(**data)


class ProductProjectionPagedSearchResponseSchema(PagedQueryResponseSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductProjectionPagedSearchResponse`."
    results = marshmallow.fields.Nested(
        nested="commercetools.schemas._product.ProductProjectionSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )
    facets = marshmallow.fields.Nested(
        nested="commercetools.schemas._product.FacetResultsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ProductProjectionPagedSearchResponse(**data)


class ProductProjectionSchema(ResourceSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductProjection`."
    key = marshmallow.fields.String(allow_none=True, missing=None)
    product_type = marshmallow.fields.Nested(
        nested="commercetools.schemas._product_type.ProductTypeReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="productType",
    )
    name = LocalizedStringField(allow_none=True)
    description = LocalizedStringField(allow_none=True, missing=None)
    slug = LocalizedStringField(allow_none=True)
    categories = marshmallow.fields.Nested(
        nested="commercetools.schemas._category.CategoryReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )
    category_order_hints = CategoryOrderHintsField(
        allow_none=True, missing=None, data_key="categoryOrderHints"
    )
    meta_title = LocalizedStringField(
        allow_none=True, missing=None, data_key="metaTitle"
    )
    meta_description = LocalizedStringField(
        allow_none=True, missing=None, data_key="metaDescription"
    )
    meta_keywords = LocalizedStringField(
        allow_none=True, missing=None, data_key="metaKeywords"
    )
    search_keywords = marshmallow.fields.Nested(
        nested="commercetools.schemas._product.SearchKeywordsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="searchKeywords",
    )
    has_staged_changes = marshmallow.fields.Bool(
        allow_none=True, missing=None, data_key="hasStagedChanges"
    )
    published = marshmallow.fields.Bool(allow_none=True, missing=None)
    master_variant = marshmallow.fields.Nested(
        nested="commercetools.schemas._product.ProductVariantSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="masterVariant",
    )
    variants = marshmallow.fields.Nested(
        nested="commercetools.schemas._product.ProductVariantSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )
    tax_category = marshmallow.fields.Nested(
        nested="commercetools.schemas._tax_category.TaxCategoryReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="taxCategory",
    )
    state = marshmallow.fields.Nested(
        nested="commercetools.schemas._state.StateReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    review_rating_statistics = marshmallow.fields.Nested(
        nested="commercetools.schemas._review.ReviewRatingStatisticsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="reviewRatingStatistics",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ProductProjection(**data)


class ProductReferenceSchema(ReferenceSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductReference`."
    obj = marshmallow.fields.Nested(
        nested="commercetools.schemas._product.ProductSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type_id"]
        return types.ProductReference(**data)


class ProductSchema(ResourceSchema):
    "Marshmallow schema for :class:`commercetools.types.Product`."
    key = marshmallow.fields.String(allow_none=True, missing=None)
    product_type = marshmallow.fields.Nested(
        nested="commercetools.schemas._product_type.ProductTypeReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="productType",
    )
    master_data = marshmallow.fields.Nested(
        nested="commercetools.schemas._product.ProductCatalogDataSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="masterData",
    )
    tax_category = marshmallow.fields.Nested(
        nested="commercetools.schemas._tax_category.TaxCategoryReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="taxCategory",
    )
    state = marshmallow.fields.Nested(
        nested="commercetools.schemas._state.StateReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    review_rating_statistics = marshmallow.fields.Nested(
        nested="commercetools.schemas._review.ReviewRatingStatisticsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="reviewRatingStatistics",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.Product(**data)


class ProductUpdateActionSchema(UpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductUpdateAction`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductUpdateAction(**data)


class ProductUpdateSchema(UpdateSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductUpdate`."
    actions = marshmallow.fields.List(
        helpers.Discriminator(
            discriminator_field=("action", "action"),
            discriminator_schemas={
                "addAsset": "commercetools.schemas._product.ProductAddAssetActionSchema",
                "addExternalImage": "commercetools.schemas._product.ProductAddExternalImageActionSchema",
                "addPrice": "commercetools.schemas._product.ProductAddPriceActionSchema",
                "addToCategory": "commercetools.schemas._product.ProductAddToCategoryActionSchema",
                "addVariant": "commercetools.schemas._product.ProductAddVariantActionSchema",
                "changeAssetName": "commercetools.schemas._product.ProductChangeAssetNameActionSchema",
                "changeAssetOrder": "commercetools.schemas._product.ProductChangeAssetOrderActionSchema",
                "changeMasterVariant": "commercetools.schemas._product.ProductChangeMasterVariantActionSchema",
                "changeName": "commercetools.schemas._product.ProductChangeNameActionSchema",
                "changePrice": "commercetools.schemas._product.ProductChangePriceActionSchema",
                "changeSlug": "commercetools.schemas._product.ProductChangeSlugActionSchema",
                "legacySetSku": "commercetools.schemas._product.ProductLegacySetSkuActionSchema",
                "moveImageToPosition": "commercetools.schemas._product.ProductMoveImageToPositionActionSchema",
                "publish": "commercetools.schemas._product.ProductPublishActionSchema",
                "removeAsset": "commercetools.schemas._product.ProductRemoveAssetActionSchema",
                "removeFromCategory": "commercetools.schemas._product.ProductRemoveFromCategoryActionSchema",
                "removeImage": "commercetools.schemas._product.ProductRemoveImageActionSchema",
                "removePrice": "commercetools.schemas._product.ProductRemovePriceActionSchema",
                "removeVariant": "commercetools.schemas._product.ProductRemoveVariantActionSchema",
                "revertStagedChanges": "commercetools.schemas._product.ProductRevertStagedChangesActionSchema",
                "revertStagedVariantChanges": "commercetools.schemas._product.ProductRevertStagedVariantChangesActionSchema",
                "setAssetCustomField": "commercetools.schemas._product.ProductSetAssetCustomFieldActionSchema",
                "setAssetCustomType": "commercetools.schemas._product.ProductSetAssetCustomTypeActionSchema",
                "setAssetDescription": "commercetools.schemas._product.ProductSetAssetDescriptionActionSchema",
                "setAssetKey": "commercetools.schemas._product.ProductSetAssetKeyActionSchema",
                "setAssetSources": "commercetools.schemas._product.ProductSetAssetSourcesActionSchema",
                "setAssetTags": "commercetools.schemas._product.ProductSetAssetTagsActionSchema",
                "setAttribute": "commercetools.schemas._product.ProductSetAttributeActionSchema",
                "setAttributeInAllVariants": "commercetools.schemas._product.ProductSetAttributeInAllVariantsActionSchema",
                "setCategoryOrderHint": "commercetools.schemas._product.ProductSetCategoryOrderHintActionSchema",
                "setDescription": "commercetools.schemas._product.ProductSetDescriptionActionSchema",
                "setDiscountedPrice": "commercetools.schemas._product.ProductSetDiscountedPriceActionSchema",
                "setImageLabel": "commercetools.schemas._product.ProductSetImageLabelActionSchema",
                "setKey": "commercetools.schemas._product.ProductSetKeyActionSchema",
                "setMetaDescription": "commercetools.schemas._product.ProductSetMetaDescriptionActionSchema",
                "setMetaKeywords": "commercetools.schemas._product.ProductSetMetaKeywordsActionSchema",
                "setMetaTitle": "commercetools.schemas._product.ProductSetMetaTitleActionSchema",
                "setPrices": "commercetools.schemas._product.ProductSetPricesActionSchema",
                "setProductPriceCustomField": "commercetools.schemas._product.ProductSetProductPriceCustomFieldActionSchema",
                "setProductPriceCustomType": "commercetools.schemas._product.ProductSetProductPriceCustomTypeActionSchema",
                "setProductVariantKey": "commercetools.schemas._product.ProductSetProductVariantKeyActionSchema",
                "setSearchKeywords": "commercetools.schemas._product.ProductSetSearchKeywordsActionSchema",
                "setSku": "commercetools.schemas._product.ProductSetSkuActionSchema",
                "setTaxCategory": "commercetools.schemas._product.ProductSetTaxCategoryActionSchema",
                "transitionState": "commercetools.schemas._product.ProductTransitionStateActionSchema",
                "unpublish": "commercetools.schemas._product.ProductUnpublishActionSchema",
            },
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        ),
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ProductUpdate(**data)


class ProductVariantAvailabilitySchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ProductVariantAvailability`."
    is_on_stock = marshmallow.fields.Bool(
        allow_none=True, missing=None, data_key="isOnStock"
    )
    restockable_in_days = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="restockableInDays"
    )
    available_quantity = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="availableQuantity"
    )
    channels = marshmallow.fields.Nested(
        nested="commercetools.schemas._product.ProductVariantChannelAvailabilityMapSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ProductVariantAvailability(**data)


class ProductVariantChannelAvailabilityMapSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ProductVariantChannelAvailabilityMap`."
    _regex = helpers.RegexField(
        unknown=marshmallow.EXCLUDE,
        pattern=re.compile(""),
        type=marshmallow.fields.Nested(
            nested="commercetools.schemas._product.ProductVariantChannelAvailabilitySchema",
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        ),
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        data = self.fields["_regex"].postprocess(data)
        return types.ProductVariantChannelAvailabilityMap(**data)

    @marshmallow.pre_load
    def pre_load(self, data):
        data = self.fields["_regex"].preprocess(data)
        return data

    @marshmallow.pre_dump
    def pre_dump(self, data):
        data = self.fields["_regex"].preprocess(data)
        return data

    @marshmallow.post_dump
    def post_dump(self, data):
        data = self.fields["_regex"].postprocess(data)
        return data


class ProductVariantChannelAvailabilitySchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ProductVariantChannelAvailability`."
    is_on_stock = marshmallow.fields.Bool(
        allow_none=True, missing=None, data_key="isOnStock"
    )
    restockable_in_days = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="restockableInDays"
    )
    available_quantity = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="availableQuantity"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ProductVariantChannelAvailability(**data)


class ProductVariantDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ProductVariantDraft`."
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    key = marshmallow.fields.String(allow_none=True, missing=None)
    prices = marshmallow.fields.Nested(
        nested="commercetools.schemas._common.PriceDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )
    attributes = marshmallow.fields.Nested(
        nested="commercetools.schemas._product.AttributeSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )
    images = marshmallow.fields.Nested(
        nested="commercetools.schemas._common.ImageSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )
    assets = marshmallow.fields.Nested(
        nested="commercetools.schemas._common.AssetDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ProductVariantDraft(**data)


class ProductVariantSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ProductVariant`."
    id = marshmallow.fields.Integer(allow_none=True)
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    key = marshmallow.fields.String(allow_none=True, missing=None)
    prices = marshmallow.fields.Nested(
        nested="commercetools.schemas._common.PriceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )
    attributes = marshmallow.fields.Nested(
        nested="commercetools.schemas._product.AttributeSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )
    price = marshmallow.fields.Nested(
        nested="commercetools.schemas._common.PriceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    images = marshmallow.fields.Nested(
        nested="commercetools.schemas._common.ImageSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )
    assets = marshmallow.fields.Nested(
        nested="commercetools.schemas._common.AssetSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )
    availability = marshmallow.fields.Nested(
        nested="commercetools.schemas._product.ProductVariantAvailabilitySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    is_matching_variant = marshmallow.fields.Bool(
        allow_none=True, missing=None, data_key="isMatchingVariant"
    )
    scoped_price = marshmallow.fields.Nested(
        nested="commercetools.schemas._common.ScopedPriceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="scopedPrice",
    )
    scoped_price_discounted = marshmallow.fields.Bool(
        allow_none=True, missing=None, data_key="scopedPriceDiscounted"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ProductVariant(**data)


class SearchKeywordSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.SearchKeyword`."
    text = marshmallow.fields.String(allow_none=True)
    suggest_tokenizer = helpers.Discriminator(
        discriminator_field=("type", "type"),
        discriminator_schemas={
            "custom": "commercetools.schemas._product.CustomTokenizerSchema",
            "whitespace": "commercetools.schemas._product.WhitespaceTokenizerSchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="suggestTokenizer",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.SearchKeyword(**data)


class SearchKeywordsSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.SearchKeywords`."
    _regex = helpers.RegexField(
        unknown=marshmallow.EXCLUDE,
        pattern=re.compile("^[a-z]{2}(-[A-Z]{2})?$"),
        type=marshmallow.fields.Nested(
            nested="commercetools.schemas._product.SearchKeywordSchema",
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
            many=True,
        ),
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        data = self.fields["_regex"].postprocess(data)
        return types.SearchKeywords(**data)

    @marshmallow.pre_load
    def pre_load(self, data):
        data = self.fields["_regex"].preprocess(data)
        return data

    @marshmallow.pre_dump
    def pre_dump(self, data):
        data = self.fields["_regex"].preprocess(data)
        return data

    @marshmallow.post_dump
    def post_dump(self, data):
        data = self.fields["_regex"].postprocess(data)
        return data


class SuggestTokenizerSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.SuggestTokenizer`."
    type = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.SuggestTokenizer(**data)


class SuggestionResultSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.SuggestionResult`."
    _regex = helpers.RegexField(
        unknown=marshmallow.EXCLUDE,
        pattern=re.compile("searchKeywords.[a-z]{2}(-[A-Z]{2})?"),
        type=marshmallow.fields.List(
            marshmallow.fields.Nested(
                nested="commercetools.schemas._product.SuggestionSchema",
                unknown=marshmallow.EXCLUDE,
                allow_none=True,
            ),
            allow_none=True,
        ),
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        data = self.fields["_regex"].postprocess(data)
        return types.SuggestionResult(**data)

    @marshmallow.pre_load
    def pre_load(self, data):
        data = self.fields["_regex"].preprocess(data)
        return data

    @marshmallow.pre_dump
    def pre_dump(self, data):
        data = self.fields["_regex"].preprocess(data)
        return data

    @marshmallow.post_dump
    def post_dump(self, data):
        data = self.fields["_regex"].postprocess(data)
        return data


class SuggestionSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.Suggestion`."
    text = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.Suggestion(**data)


class CustomTokenizerSchema(SuggestTokenizerSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomTokenizer`."
    inputs = marshmallow.fields.List(marshmallow.fields.String(allow_none=True))

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.CustomTokenizer(**data)


class FilteredFacetResultSchema(FacetResultSchema):
    "Marshmallow schema for :class:`commercetools.types.FilteredFacetResult`."
    count = marshmallow.fields.Integer(allow_none=True)
    product_count = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="productCount"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.FilteredFacetResult(**data)


class ProductAddAssetActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductAddAssetAction`."
    variant_id = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="variantId"
    )
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)
    asset = marshmallow.fields.Nested(
        nested="commercetools.schemas._common.AssetDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    position = marshmallow.fields.Integer(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductAddAssetAction(**data)


class ProductAddExternalImageActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductAddExternalImageAction`."
    variant_id = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="variantId"
    )
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    image = marshmallow.fields.Nested(
        nested="commercetools.schemas._common.ImageSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductAddExternalImageAction(**data)


class ProductAddPriceActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductAddPriceAction`."
    variant_id = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="variantId"
    )
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    price = marshmallow.fields.Nested(
        nested="commercetools.schemas._common.PriceDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductAddPriceAction(**data)


class ProductAddToCategoryActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductAddToCategoryAction`."
    category = marshmallow.fields.Nested(
        nested="commercetools.schemas._category.CategoryReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    order_hint = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="orderHint"
    )
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductAddToCategoryAction(**data)


class ProductAddVariantActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductAddVariantAction`."
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    key = marshmallow.fields.String(allow_none=True, missing=None)
    prices = marshmallow.fields.Nested(
        nested="commercetools.schemas._common.PriceDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )
    images = marshmallow.fields.Nested(
        nested="commercetools.schemas._common.ImageSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )
    attributes = marshmallow.fields.Nested(
        nested="commercetools.schemas._product.AttributeSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductAddVariantAction(**data)


class ProductChangeAssetNameActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductChangeAssetNameAction`."
    variant_id = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="variantId"
    )
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)
    asset_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="assetId"
    )
    asset_key = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="assetKey"
    )
    name = LocalizedStringField(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductChangeAssetNameAction(**data)


class ProductChangeAssetOrderActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductChangeAssetOrderAction`."
    variant_id = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="variantId"
    )
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)
    asset_order = marshmallow.fields.List(
        marshmallow.fields.String(allow_none=True), data_key="assetOrder"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductChangeAssetOrderAction(**data)


class ProductChangeMasterVariantActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductChangeMasterVariantAction`."
    variant_id = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="variantId"
    )
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductChangeMasterVariantAction(**data)


class ProductChangeNameActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductChangeNameAction`."
    name = LocalizedStringField(allow_none=True)
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductChangeNameAction(**data)


class ProductChangePriceActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductChangePriceAction`."
    price_id = marshmallow.fields.String(allow_none=True, data_key="priceId")
    price = marshmallow.fields.Nested(
        nested="commercetools.schemas._common.PriceDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductChangePriceAction(**data)


class ProductChangeSlugActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductChangeSlugAction`."
    slug = LocalizedStringField(allow_none=True)
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductChangeSlugAction(**data)


class ProductLegacySetSkuActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductLegacySetSkuAction`."
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    variant_id = marshmallow.fields.Integer(allow_none=True, data_key="variantId")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductLegacySetSkuAction(**data)


class ProductMoveImageToPositionActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductMoveImageToPositionAction`."
    variant_id = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="variantId"
    )
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    image_url = marshmallow.fields.String(allow_none=True, data_key="imageUrl")
    position = marshmallow.fields.Integer(allow_none=True)
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductMoveImageToPositionAction(**data)


class ProductPublishActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductPublishAction`."
    scope = marshmallow_enum.EnumField(
        types.ProductPublishScope, by_value=True, missing=None
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductPublishAction(**data)


class ProductRemoveAssetActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductRemoveAssetAction`."
    variant_id = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="variantId"
    )
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)
    asset_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="assetId"
    )
    asset_key = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="assetKey"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductRemoveAssetAction(**data)


class ProductRemoveFromCategoryActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductRemoveFromCategoryAction`."
    category = marshmallow.fields.Nested(
        nested="commercetools.schemas._category.CategoryReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductRemoveFromCategoryAction(**data)


class ProductRemoveImageActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductRemoveImageAction`."
    variant_id = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="variantId"
    )
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    image_url = marshmallow.fields.String(allow_none=True, data_key="imageUrl")
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductRemoveImageAction(**data)


class ProductRemovePriceActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductRemovePriceAction`."
    price_id = marshmallow.fields.String(allow_none=True, data_key="priceId")
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductRemovePriceAction(**data)


class ProductRemoveVariantActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductRemoveVariantAction`."
    id = marshmallow.fields.Integer(allow_none=True, missing=None)
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductRemoveVariantAction(**data)


class ProductRevertStagedChangesActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductRevertStagedChangesAction`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductRevertStagedChangesAction(**data)


class ProductRevertStagedVariantChangesActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductRevertStagedVariantChangesAction`."
    variant_id = marshmallow.fields.Integer(allow_none=True, data_key="variantId")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductRevertStagedVariantChangesAction(**data)


class ProductSetAssetCustomFieldActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductSetAssetCustomFieldAction`."
    variant_id = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="variantId"
    )
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)
    asset_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="assetId"
    )
    asset_key = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="assetKey"
    )
    name = marshmallow.fields.String(allow_none=True)
    value = marshmallow.fields.Raw(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductSetAssetCustomFieldAction(**data)


class ProductSetAssetCustomTypeActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductSetAssetCustomTypeAction`."
    variant_id = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="variantId"
    )
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)
    asset_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="assetId"
    )
    asset_key = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="assetKey"
    )
    type = marshmallow.fields.Nested(
        nested="commercetools.schemas._type.TypeReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    fields = marshmallow.fields.Dict(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductSetAssetCustomTypeAction(**data)


class ProductSetAssetDescriptionActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductSetAssetDescriptionAction`."
    variant_id = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="variantId"
    )
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)
    asset_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="assetId"
    )
    asset_key = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="assetKey"
    )
    description = LocalizedStringField(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductSetAssetDescriptionAction(**data)


class ProductSetAssetKeyActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductSetAssetKeyAction`."
    variant_id = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="variantId"
    )
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)
    asset_id = marshmallow.fields.String(allow_none=True, data_key="assetId")
    asset_key = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="assetKey"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductSetAssetKeyAction(**data)


class ProductSetAssetSourcesActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductSetAssetSourcesAction`."
    variant_id = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="variantId"
    )
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)
    asset_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="assetId"
    )
    asset_key = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="assetKey"
    )
    sources = marshmallow.fields.Nested(
        nested="commercetools.schemas._common.AssetSourceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductSetAssetSourcesAction(**data)


class ProductSetAssetTagsActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductSetAssetTagsAction`."
    variant_id = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="variantId"
    )
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)
    asset_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="assetId"
    )
    asset_key = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="assetKey"
    )
    tags = marshmallow.fields.List(
        marshmallow.fields.String(allow_none=True), missing=None
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductSetAssetTagsAction(**data)


class ProductSetAttributeActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductSetAttributeAction`."
    variant_id = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="variantId"
    )
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    name = marshmallow.fields.String(allow_none=True)
    value = marshmallow.fields.Raw(allow_none=True, missing=None)
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductSetAttributeAction(**data)


class ProductSetAttributeInAllVariantsActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductSetAttributeInAllVariantsAction`."
    name = marshmallow.fields.String(allow_none=True)
    value = marshmallow.fields.Raw(allow_none=True, missing=None)
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductSetAttributeInAllVariantsAction(**data)


class ProductSetCategoryOrderHintActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductSetCategoryOrderHintAction`."
    category_id = marshmallow.fields.String(allow_none=True, data_key="categoryId")
    order_hint = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="orderHint"
    )
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductSetCategoryOrderHintAction(**data)


class ProductSetDescriptionActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductSetDescriptionAction`."
    description = LocalizedStringField(allow_none=True, missing=None)
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductSetDescriptionAction(**data)


class ProductSetDiscountedPriceActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductSetDiscountedPriceAction`."
    price_id = marshmallow.fields.String(allow_none=True, data_key="priceId")
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)
    discounted = marshmallow.fields.Nested(
        nested="commercetools.schemas._common.DiscountedPriceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductSetDiscountedPriceAction(**data)


class ProductSetImageLabelActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductSetImageLabelAction`."
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    variant_id = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="variantId"
    )
    image_url = marshmallow.fields.String(allow_none=True, data_key="imageUrl")
    label = marshmallow.fields.String(allow_none=True, missing=None)
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductSetImageLabelAction(**data)


class ProductSetKeyActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductSetKeyAction`."
    key = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductSetKeyAction(**data)


class ProductSetMetaDescriptionActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductSetMetaDescriptionAction`."
    meta_description = LocalizedStringField(
        allow_none=True, missing=None, data_key="metaDescription"
    )
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductSetMetaDescriptionAction(**data)


class ProductSetMetaKeywordsActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductSetMetaKeywordsAction`."
    meta_keywords = LocalizedStringField(
        allow_none=True, missing=None, data_key="metaKeywords"
    )
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductSetMetaKeywordsAction(**data)


class ProductSetMetaTitleActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductSetMetaTitleAction`."
    meta_title = LocalizedStringField(
        allow_none=True, missing=None, data_key="metaTitle"
    )
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductSetMetaTitleAction(**data)


class ProductSetPricesActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductSetPricesAction`."
    variant_id = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="variantId"
    )
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    prices = marshmallow.fields.Nested(
        nested="commercetools.schemas._common.PriceDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductSetPricesAction(**data)


class ProductSetProductPriceCustomFieldActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductSetProductPriceCustomFieldAction`."
    price_id = marshmallow.fields.String(allow_none=True, data_key="priceId")
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)
    name = marshmallow.fields.String(allow_none=True)
    value = marshmallow.fields.Raw(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductSetProductPriceCustomFieldAction(**data)


class ProductSetProductPriceCustomTypeActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductSetProductPriceCustomTypeAction`."
    price_id = marshmallow.fields.String(allow_none=True, data_key="priceId")
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)
    type = marshmallow.fields.Nested(
        nested="commercetools.schemas._type.TypeReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    fields = FieldContainerField(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductSetProductPriceCustomTypeAction(**data)


class ProductSetProductVariantKeyActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductSetProductVariantKeyAction`."
    variant_id = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="variantId"
    )
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    key = marshmallow.fields.String(allow_none=True, missing=None)
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductSetProductVariantKeyAction(**data)


class ProductSetSearchKeywordsActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductSetSearchKeywordsAction`."
    search_keywords = marshmallow.fields.Nested(
        nested="commercetools.schemas._product.SearchKeywordsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="searchKeywords",
    )
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductSetSearchKeywordsAction(**data)


class ProductSetSkuActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductSetSkuAction`."
    variant_id = marshmallow.fields.Integer(allow_none=True, data_key="variantId")
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductSetSkuAction(**data)


class ProductSetTaxCategoryActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductSetTaxCategoryAction`."
    tax_category = marshmallow.fields.Nested(
        nested="commercetools.schemas._tax_category.TaxCategoryReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="taxCategory",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductSetTaxCategoryAction(**data)


class ProductTransitionStateActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductTransitionStateAction`."
    state = marshmallow.fields.Nested(
        nested="commercetools.schemas._state.StateReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    force = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductTransitionStateAction(**data)


class ProductUnpublishActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductUnpublishAction`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductUnpublishAction(**data)


class RangeFacetResultSchema(FacetResultSchema):
    "Marshmallow schema for :class:`commercetools.types.RangeFacetResult`."
    ranges = marshmallow.fields.Nested(
        nested="commercetools.schemas._product.FacetResultRangeSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.RangeFacetResult(**data)


class TermFacetResultSchema(FacetResultSchema):
    "Marshmallow schema for :class:`commercetools.types.TermFacetResult`."
    data_type = marshmallow_enum.EnumField(
        types.TermFacetResultType, by_value=True, data_key="dataType"
    )
    missing = marshmallow.fields.Integer(allow_none=True)
    total = marshmallow.fields.Integer(allow_none=True)
    other = marshmallow.fields.Integer(allow_none=True)
    terms = marshmallow.fields.Nested(
        nested="commercetools.schemas._product.FacetResultTermSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.TermFacetResult(**data)


class WhitespaceTokenizerSchema(SuggestTokenizerSchema):
    "Marshmallow schema for :class:`commercetools.types.WhitespaceTokenizer`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.WhitespaceTokenizer(**data)
