# DO NOT EDIT! This file is automatically generated

import datetime
import typing

import attr

from commercetools.types._base import Update, UpdateAction
from commercetools.types._shipping_method import ShippingRateTierType

if typing.TYPE_CHECKING:
    from ._message import MessageConfiguration, MessageConfigurationDraft
__all__ = [
    "CartClassificationType",
    "CartScoreType",
    "CartValueType",
    "Project",
    "ProjectChangeCountriesAction",
    "ProjectChangeCurrenciesAction",
    "ProjectChangeLanguagesAction",
    "ProjectChangeMessagesConfigurationAction",
    "ProjectChangeMessagesEnabledAction",
    "ProjectChangeNameAction",
    "ProjectSetShippingRateInputTypeAction",
    "ProjectUpdate",
    "ProjectUpdateAction",
    "ShippingRateInputType",
]


@attr.s(auto_attribs=True, init=False, repr=False)
class Project:
    "Corresponding marshmallow schema is :class:`commercetools.schemas.ProjectSchema`."
    #: :class:`int`
    version: typing.Optional[int]
    #: :class:`str`
    key: typing.Optional[str]
    #: :class:`str`
    name: typing.Optional[str]
    #: List of :class:`str`
    countries: typing.Optional[typing.List["str"]]
    #: List of :class:`str`
    currencies: typing.Optional[typing.List["str"]]
    #: List of :class:`str`
    languages: typing.Optional[typing.List["str"]]
    #: :class:`datetime.datetime` `(Named` ``createdAt`` `in Commercetools)`
    created_at: typing.Optional[datetime.datetime]
    #: Optional :class:`str` `(Named` ``trialUntil`` `in Commercetools)`
    trial_until: typing.Optional[str]
    #: :class:`commercetools.types.MessageConfiguration`
    messages: typing.Optional["MessageConfiguration"]
    #: Optional :class:`commercetools.types.ShippingRateInputType` `(Named` ``shippingRateInputType`` `in Commercetools)`
    shipping_rate_input_type: typing.Optional["ShippingRateInputType"]

    def __init__(
        self,
        *,
        version: typing.Optional[int] = None,
        key: typing.Optional[str] = None,
        name: typing.Optional[str] = None,
        countries: typing.Optional[typing.List["str"]] = None,
        currencies: typing.Optional[typing.List["str"]] = None,
        languages: typing.Optional[typing.List["str"]] = None,
        created_at: typing.Optional[datetime.datetime] = None,
        trial_until: typing.Optional[str] = None,
        messages: typing.Optional["MessageConfiguration"] = None,
        shipping_rate_input_type: typing.Optional["ShippingRateInputType"] = None
    ) -> None:
        self.version = version
        self.key = key
        self.name = name
        self.countries = countries
        self.currencies = currencies
        self.languages = languages
        self.created_at = created_at
        self.trial_until = trial_until
        self.messages = messages
        self.shipping_rate_input_type = shipping_rate_input_type

    def __repr__(self) -> str:
        return (
            "Project(version=%r, key=%r, name=%r, countries=%r, currencies=%r, languages=%r, created_at=%r, trial_until=%r, messages=%r, shipping_rate_input_type=%r)"
            % (
                self.version,
                self.key,
                self.name,
                self.countries,
                self.currencies,
                self.languages,
                self.created_at,
                self.trial_until,
                self.messages,
                self.shipping_rate_input_type,
            )
        )


@attr.s(auto_attribs=True, init=False, repr=False)
class ShippingRateInputType:
    "Corresponding marshmallow schema is :class:`commercetools.schemas.ShippingRateInputTypeSchema`."
    #: :class:`commercetools.types.ShippingRateTierType`
    type: typing.Optional["ShippingRateTierType"]

    def __init__(self, *, type: typing.Optional["ShippingRateTierType"] = None) -> None:
        self.type = type

    def __repr__(self) -> str:
        return "ShippingRateInputType(type=%r)" % (self.type,)


@attr.s(auto_attribs=True, init=False, repr=False)
class CartClassificationType(ShippingRateInputType):
    "Corresponding marshmallow schema is :class:`commercetools.schemas.CartClassificationTypeSchema`."
    #: :class:`list`
    values: typing.Optional[list]

    def __init__(
        self,
        *,
        type: typing.Optional["ShippingRateTierType"] = None,
        values: typing.Optional[list] = None
    ) -> None:
        self.values = values
        super().__init__(type=ShippingRateTierType.CART_CLASSIFICATION)

    def __repr__(self) -> str:
        return "CartClassificationType(type=%r, values=%r)" % (self.type, self.values)


@attr.s(auto_attribs=True, init=False, repr=False)
class CartScoreType(ShippingRateInputType):
    "Corresponding marshmallow schema is :class:`commercetools.schemas.CartScoreTypeSchema`."

    def __init__(self, *, type: typing.Optional["ShippingRateTierType"] = None) -> None:
        super().__init__(type=ShippingRateTierType.CART_SCORE)

    def __repr__(self) -> str:
        return "CartScoreType(type=%r)" % (self.type,)


@attr.s(auto_attribs=True, init=False, repr=False)
class CartValueType(ShippingRateInputType):
    "Corresponding marshmallow schema is :class:`commercetools.schemas.CartValueTypeSchema`."

    def __init__(self, *, type: typing.Optional["ShippingRateTierType"] = None) -> None:
        super().__init__(type=ShippingRateTierType.CART_VALUE)

    def __repr__(self) -> str:
        return "CartValueType(type=%r)" % (self.type,)


@attr.s(auto_attribs=True, init=False, repr=False)
class ProjectUpdate(Update):
    "Corresponding marshmallow schema is :class:`commercetools.schemas.ProjectUpdateSchema`."
    #: :class:`list`
    actions: typing.Optional[list]

    def __init__(
        self,
        *,
        version: typing.Optional[int] = None,
        actions: typing.Optional[list] = None
    ) -> None:
        self.actions = actions
        super().__init__(version=version, actions=actions)

    def __repr__(self) -> str:
        return "ProjectUpdate(version=%r, actions=%r)" % (self.version, self.actions)


@attr.s(auto_attribs=True, init=False, repr=False)
class ProjectUpdateAction(UpdateAction):
    "Corresponding marshmallow schema is :class:`commercetools.schemas.ProjectUpdateActionSchema`."

    def __init__(self, *, action: typing.Optional[str] = None) -> None:
        super().__init__(action=action)

    def __repr__(self) -> str:
        return "ProjectUpdateAction(action=%r)" % (self.action,)


@attr.s(auto_attribs=True, init=False, repr=False)
class ProjectChangeCountriesAction(ProjectUpdateAction):
    "Corresponding marshmallow schema is :class:`commercetools.schemas.ProjectChangeCountriesActionSchema`."
    #: List of :class:`str`
    countries: typing.Optional[typing.List["str"]]

    def __init__(
        self,
        *,
        action: typing.Optional[str] = None,
        countries: typing.Optional[typing.List["str"]] = None
    ) -> None:
        self.countries = countries
        super().__init__(action="changeCountries")

    def __repr__(self) -> str:
        return "ProjectChangeCountriesAction(action=%r, countries=%r)" % (
            self.action,
            self.countries,
        )


@attr.s(auto_attribs=True, init=False, repr=False)
class ProjectChangeCurrenciesAction(ProjectUpdateAction):
    "Corresponding marshmallow schema is :class:`commercetools.schemas.ProjectChangeCurrenciesActionSchema`."
    #: List of :class:`str`
    currencies: typing.Optional[typing.List["str"]]

    def __init__(
        self,
        *,
        action: typing.Optional[str] = None,
        currencies: typing.Optional[typing.List["str"]] = None
    ) -> None:
        self.currencies = currencies
        super().__init__(action="changeCurrencies")

    def __repr__(self) -> str:
        return "ProjectChangeCurrenciesAction(action=%r, currencies=%r)" % (
            self.action,
            self.currencies,
        )


@attr.s(auto_attribs=True, init=False, repr=False)
class ProjectChangeLanguagesAction(ProjectUpdateAction):
    "Corresponding marshmallow schema is :class:`commercetools.schemas.ProjectChangeLanguagesActionSchema`."
    #: List of :class:`str`
    languages: typing.Optional[typing.List["str"]]

    def __init__(
        self,
        *,
        action: typing.Optional[str] = None,
        languages: typing.Optional[typing.List["str"]] = None
    ) -> None:
        self.languages = languages
        super().__init__(action="changeLanguages")

    def __repr__(self) -> str:
        return "ProjectChangeLanguagesAction(action=%r, languages=%r)" % (
            self.action,
            self.languages,
        )


@attr.s(auto_attribs=True, init=False, repr=False)
class ProjectChangeMessagesConfigurationAction(ProjectUpdateAction):
    "Corresponding marshmallow schema is :class:`commercetools.schemas.ProjectChangeMessagesConfigurationActionSchema`."
    #: :class:`commercetools.types.MessageConfigurationDraft` `(Named` ``messagesConfiguration`` `in Commercetools)`
    messages_configuration: typing.Optional["MessageConfigurationDraft"]

    def __init__(
        self,
        *,
        action: typing.Optional[str] = None,
        messages_configuration: typing.Optional["MessageConfigurationDraft"] = None
    ) -> None:
        self.messages_configuration = messages_configuration
        super().__init__(action="changeMessagesConfiguration")

    def __repr__(self) -> str:
        return (
            "ProjectChangeMessagesConfigurationAction(action=%r, messages_configuration=%r)"
            % (self.action, self.messages_configuration)
        )


@attr.s(auto_attribs=True, init=False, repr=False)
class ProjectChangeMessagesEnabledAction(ProjectUpdateAction):
    "Corresponding marshmallow schema is :class:`commercetools.schemas.ProjectChangeMessagesEnabledActionSchema`."
    #: :class:`bool` `(Named` ``messagesEnabled`` `in Commercetools)`
    messages_enabled: typing.Optional[bool]

    def __init__(
        self,
        *,
        action: typing.Optional[str] = None,
        messages_enabled: typing.Optional[bool] = None
    ) -> None:
        self.messages_enabled = messages_enabled
        super().__init__(action="changeMessagesEnabled")

    def __repr__(self) -> str:
        return "ProjectChangeMessagesEnabledAction(action=%r, messages_enabled=%r)" % (
            self.action,
            self.messages_enabled,
        )


@attr.s(auto_attribs=True, init=False, repr=False)
class ProjectChangeNameAction(ProjectUpdateAction):
    "Corresponding marshmallow schema is :class:`commercetools.schemas.ProjectChangeNameActionSchema`."
    #: :class:`str`
    name: typing.Optional[str]

    def __init__(
        self, *, action: typing.Optional[str] = None, name: typing.Optional[str] = None
    ) -> None:
        self.name = name
        super().__init__(action="changeName")

    def __repr__(self) -> str:
        return "ProjectChangeNameAction(action=%r, name=%r)" % (self.action, self.name)


@attr.s(auto_attribs=True, init=False, repr=False)
class ProjectSetShippingRateInputTypeAction(ProjectUpdateAction):
    "Corresponding marshmallow schema is :class:`commercetools.schemas.ProjectSetShippingRateInputTypeActionSchema`."
    #: Optional :class:`commercetools.types.ShippingRateInputType` `(Named` ``shippingRateInputType`` `in Commercetools)`
    shipping_rate_input_type: typing.Optional["ShippingRateInputType"]

    def __init__(
        self,
        *,
        action: typing.Optional[str] = None,
        shipping_rate_input_type: typing.Optional["ShippingRateInputType"] = None
    ) -> None:
        self.shipping_rate_input_type = shipping_rate_input_type
        super().__init__(action="setShippingRateInputType")

    def __repr__(self) -> str:
        return (
            "ProjectSetShippingRateInputTypeAction(action=%r, shipping_rate_input_type=%r)"
            % (self.action, self.shipping_rate_input_type)
        )
